Class QZWeapon : Weapon {
	Default {
		+WEAPON.WIMPY_WEAPON;
		DamageType "Q";
		Height 32;
		Inventory.PickupSound "weapons/pkup";
		Radius 24;
		Weapon.BobRangeX 0.5;
		Weapon.BobRangeY 0.5;
		Weapon.BobSpeed 1.5;
		Weapon.BobStyle "InverseSmooth";
		Weapon.DefaultKickBack;
		Inventory.RespawnTics 35;
	}
	States {
		Select:
			// Reset any weapon counters.
			"####" # 0 A_SetArg(4, 3);
			// No need to wait until the weapon is selected to fire. Makes it purely cosmetic.
			"####" # 0 A_WeaponReady(WRF_NOBOB);
			Goto Selecting;
		Selecting:
			"####" # 0 A_Raise;
			"####" # 0 A_Raise;
			"####" # 0 A_Raise;
			"####" # 1;
			Loop;
		Deselect:
			// Reset any weapon counters.
			"####" # 0 A_SetArg(4, 3);
			"####" # 0 A_JumpIfHealthLower(0, "Deselecting");
			"####" # 0 A_SetUserVar("user_weapon_animation", 0);
			Goto Deselecting;
		Deselecting:
			// Forced to wait until weapon is lowered until you can fire the next weapon though.
			"####" # 0 A_Lower;
			"####" # 0 A_Lower;
			"####" # 0 A_Lower;
			"####" # 1;
			Loop;
		Ready:
			TNT1 A 4 A_WeaponReady;
			Wait;
		Fire:
			TNT1 A 1;
			Goto Ready;
		Spawn:
			TNT1 A 0;
			Stop;
	}
}

#include "actors/weapons/nailgun.zs"
#include "actors/weapons/supernailgun.zs"
#include "actors/weapons/thunderbolt.zs"