// Bypasses issue with A_CheckForReload not working correctly in GZDoom.
Class QNailgun : QZWeapon {
	int weaponFrame;
	Default {
		Inventory.Icon "W_NAILGU";
		Inventory.Pickupmessage "$Q_WEAPON_NAILGUN_PICKUP";
		Obituary "$Q_PROJECTILE_NAIL_OBITUARY";
		Tag "$Q_WEAPON_NAILGUN";
		Weapon.AmmoGive 30;
		Weapon.AmmoType "QNailAmmo";
		Weapon.AmmoUse 1;
		Weapon.SelectionOrder 2;
	}
	const PlayerAnnimation = 0;
	const ShotOffsetX = 3;
	const ShotOffsetZ = 0;
	const ViewRecoil = 1;
	States {
		Spawn:
			QNLG Z -1 NoDelay ACS_NamedExecuteAlways("Spin");
			Stop;
		Select:
			QNLG A 0 A_SetUserVar("user_weapon_animation", PlayerAnnimation);
			Goto Super::Select;
		Deselect:
			QNLG A 0;
			Goto Super::Deselect;
		Ready:
//			QNLG A 0 { invoker.weaponFrame = 0; }
			QNLG A 4 A_WeaponReady;
			Wait;
		Fire:
			QNLG # 0 A_WeaponReady(WRF_NOBOB|WRF_NOFIRE|WRF_DISABLESWITCH); // Prevent any weapon switching while firing.
			QNLG # 0 Offset(0, 32) A_GunFlash;
			QNLG # 0 ACS_NamedExecuteWithResult("Inaccuracy");
			QNLG # 0 A_PlaySound("weapons/rocket1i", CHAN_Weapon);
			QNLG # 0 A_FireCustomMissile("Null"); // Dummy fire to prevent ammo desync in Zandronum.
			QNLG # 0 ACS_NamedExecuteAlways("Recoil", 0, ViewRecoil);
			Goto ChooseFireFrame;
		ChooseFireFrame:
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 0, "FireFrame0");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 1, "FireFrame1");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 2, "FireFrame2");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 3, "FireFrame3");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 4, "FireFrame4");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 5, "FireFrame5");
			QNLG # 0 A_JumpIf(invoker.weaponFrame % 8 == 6, "FireFrame6");
			QNLG # 1 A_JumpIf(invoker.weaponFrame % 8 == 7, "FireFrame7");
			Loop;
		FireFrame0:
			QNLG B 4 A_FireCustomMissile("QNail", 0, 0, ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame1:
			QNLG C 4 A_FireCustomMissile("QNail", 0, 0, -ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame2:
			QNLG D 4 A_FireCustomMissile("QNail", 0, 0, ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame3:
			QNLG E 4 A_FireCustomMissile("QNail", 0, 0, -ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame4:
			QNLG F 4 A_FireCustomMissile("QNail", 0, 0, ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame5:
			QNLG G 4 A_FireCustomMissile("QNail", 0, 0, -ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame6:
			QNLG H 4 A_FireCustomMissile("QNail", 0, 0, ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		FireFrame7:
			QNLG I 4 A_FireCustomMissile("QNail", 0, 0, -ShotOffsetX, ShotOffsetZ);
			Goto EndFireFrame;
		EndFireFrame:
			QNLG A 0 { invoker.weaponFrame++; }
			QNLG A 0 A_Refire;
			Goto Ready;
		Flash:
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 0, "Flash0");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 1, "Flash1");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 2, "Flash2");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 3, "Flash3");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 4, "Flash4");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 5, "Flash5");
			QNLF # 0 A_JumpIf(invoker.weaponFrame % 8 == 6, "Flash6");
			QNLF # 1 A_JumpIf(invoker.weaponFrame % 8 == 7, "Flash7");
			Loop;
		Flash0:
			QNLF B 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash1:
			QNLF C 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash2:
			QNLF D 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash3:
			QNLF E 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash4:
			QNLF F 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash5:
			QNLF G 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash6:
			QNLF H 4 Bright;
			QNLF A 0 Bright;
			Stop;
		Flash7:
			QNLF I 4 Bright;
			QNLF A 0 Bright;
			Stop;
	}
}
