// Bypasses issue with A_CheckForReload not working correctly in GZDoom.
Class QSuperNailgun : QZWeapon {
	int weaponFrame;
	Default {
		Inventory.Icon "W_SNAILG";
		Inventory.Pickupmessage "$Q_WEAPON_SUPERNAILGUN_PICKUP";
		Obituary "$Q_PROJECTILE_SUPERNAIL_OBITUARY";
		Tag "$Q_WEAPON_SUPERNAILGUN";
		Weapon.AmmoGive 30;
		Weapon.AmmoType "QNailAmmo";
		Weapon.AmmoUse 2;
		Weapon.SelectionOrder 1;
	}
	const PlayerAnnimation = 0;
	const ShotOffsetCornerX = 2;
	const ShotOffsetX = 3;
	const ShotOffsetZ = 0;
	const ViewRecoil = 2;
	States {
		Spawn:
			QSNG Z -1 NoDelay ACS_NamedExecuteAlways("Spin");
			Stop;
		Select:
			QSNG A 0 A_SetUserVar("user_weapon_animation", PlayerAnnimation);
			Goto Super::Select;
		Deselect:
			QSNG A 0;
			Goto Super::Deselect;
		Ready:
			QSNG A 0 { invoker.weaponFrame = 3; }
			QSNG A 4 A_WeaponReady;
			Wait;
		Fire:
			QSNG # 0 A_WeaponReady(WRF_NOBOB|WRF_NOFIRE|WRF_DISABLESWITCH); // Prevent any weapon switching while firing;
			QSNG # 0 Offset(0, 32) A_GunFlash;
			QSNG # 0 ACS_NamedExecuteWithResult("Inaccuracy");
			QSNG # 0 A_PlaySound("weapons/spike2", CHAN_Weapon);
			QSNG # 0 A_FireCustomMissile("Null"); // Dummy fire to prevent ammo desync in Zandronum;
			QSNG # 0 ACS_NamedExecuteAlways("Recoil", 0, ViewRecoil);
			Goto ChooseFireFrame;
		ChooseFireFrame:
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 0, "FireFrame0");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 1, "FireFrame1");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 2, "FireFrame2");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 3, "FireFrame3");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 4, "FireFrame4");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 5, "FireFrame5");
			QSNG # 0 A_JumpIf(invoker.weaponFrame % 8 == 6, "FireFrame6");
			QSNG # 1 A_JumpIf(invoker.weaponFrame % 8 == 7, "FireFrame7");
			Loop;
		FireFrame0:
			QSNG B 4 A_FireCustomMissile("QSuperNail", 0, 0, ShotOffsetCornerX, ShotOffsetCornerX + ShotOffsetZ); // Top Left;
			QSNG C 0 { invoker.weaponFrame++; }
			QSNG C 0 A_Refire;
			Goto Ready;
		FireFrame1:
			QSNG C 4 A_FireCustomMissile("QSuperNail", 0, 0, -ShotOffsetX, 0 + ShotOffsetZ); // Right;
			QSNG D 0 { invoker.weaponFrame++; }
			QSNG D 4 A_Refire;
			QSNG E 0 { invoker.weaponFrame++; }
			QSNG E 0 A_Refire;
			Goto Ready;
		FireFrame2:
			QSNG D 4 A_FireCustomMissile("QSuperNail", 0, 0, ShotOffsetCornerX, -ShotOffsetCornerX + ShotOffsetZ); // Bottom Left;
			QSNG E 0 { invoker.weaponFrame++; }
			QSNG E 0 A_Refire;
			Goto Ready;
		FireFrame3:
			QSNG E 4 A_FireCustomMissile("QSuperNail", 0, 0, 0, ShotOffsetX + ShotOffsetZ); // Top;
			QSNG F 0 { invoker.weaponFrame++; }
			QSNG F 4 A_Refire;
			QSNG G 0 { invoker.weaponFrame++; }
			QSNG G 0 A_Refire;
			Goto Ready;
		FireFrame4:
			QSNG F 4 A_FireCustomMissile("QSuperNail", 0, 0, -ShotOffsetCornerX, -ShotOffsetCornerX + ShotOffsetZ); // Bottom Right;
			QSNG G 0 { invoker.weaponFrame++; }
			QSNG G 0 A_Refire;
			Goto Ready;
		FireFrame5:
			QSNG G 4 A_FireCustomMissile("QSuperNail", 0, 0, ShotOffsetX, 0 + ShotOffsetZ); // Left;
			QSNG H 0 { invoker.weaponFrame++; }
			QSNG H 4 A_Refire;
			QSNG I 0 { invoker.weaponFrame++; }
			QSNG I 0 A_Refire;
			Goto Ready;
		FireFrame6:
			QSNG H 4 A_FireCustomMissile("QSuperNail", 0, 0, -ShotOffsetCornerX, ShotOffsetCornerX + ShotOffsetZ); // Top Right;
			QSNG I 0 { invoker.weaponFrame++; }
			QSNG I 0 A_Refire;
			Goto Ready;
		FireFrame7:
			QSNG I 4 A_FireCustomMissile("QSuperNail", 0, 0, 0, -ShotOffsetX + ShotOffsetZ); // Bottom;
			QSNG B 0 { invoker.weaponFrame++; }
			QSNG B 4 A_Refire;
			QSNG C 0 { invoker.weaponFrame++; }
			QSNG C 0 A_Refire;
			Goto Ready;
		Flash:
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 0, "Flash0");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 1, "Flash1");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 2, "Flash2");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 3, "Flash3");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 4, "Flash4");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 5, "Flash5");
			QSNF # 0 A_JumpIf(invoker.weaponFrame % 8 == 6, "Flash6");
			QSNF # 1 A_JumpIf(invoker.weaponFrame % 8 == 7, "Flash7");
			Loop;
		Flash0:
			QSNF B 4 Bright;
			QSNF C 0 Bright;
			Stop;
		Flash1:
			QSNF C 4 Bright;
			QSNF D 0 Bright;
			Stop;
		Flash2:
			QSNF D 4 Bright;
			QSNF E 0 Bright;
			Stop;
		Flash3:
			QSNF E 4 Bright;
			QSNF F 0 Bright;
			Stop;
		Flash4:
			QSNF F 4 Bright;
			QSNF G 0 Bright;
			Stop;
		Flash5:
			QSNF G 4 Bright;
			QSNF H 0 Bright;
			Stop;
		Flash6:
			QSNF H 4 Bright;
			QSNF I 0 Bright;
			Stop;
		Flash7:
			QSNF I 4 Bright;
			QSNF B 0 Bright;
			Stop;
	}
}
